/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin;

import org.apache.avro.specific.SpecificData;

@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class Value extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = -6983266112810806676L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Value\",\"namespace\":\"org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin\",\"fields\":[{\"name\":\"kd_kelas\",\"type\":\"string\"},{\"name\":\"hari_ke\",\"type\":\"int\"},{\"name\":\"jam_mulai\",\"type\":{\"type\":\"long\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.MicroTime\"}},{\"name\":\"jam_selesai\",\"type\":{\"type\":\"long\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.MicroTime\"}},{\"name\":\"tgl_mulai_otomatis_buat_jadwal\",\"type\":{\"type\":\"long\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.MicroTimestamp\"}},{\"name\":\"tgl_berakhir_otomatis_buat_jadwal\",\"type\":{\"type\":\"long\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.MicroTimestamp\"}},{\"name\":\"aktif\",\"type\":\"boolean\"},{\"name\":\"kd_mk\",\"type\":[\"null\",\"string\"],\"default\":null},{\"name\":\"nama_mk\",\"type\":[\"null\",\"string\"],\"default\":null},{\"name\":\"nama_kelas\",\"type\":[\"null\",\"string\"],\"default\":null},{\"name\":\"nama_hari\",\"type\":[\"null\",\"string\"],\"default\":null},{\"name\":\"ts_update\",\"type\":{\"type\":\"long\",\"connect.version\":1,\"connect.name\":\"io.debezium.time.MicroTimestamp\"}},{\"name\":\"kd_org\",\"type\":[\"null\",\"string\"],\"default\":null},{\"name\":\"thn\",\"type\":[\"null\",\"int\"],\"default\":null},{\"name\":\"term\",\"type\":[\"null\",\"int\"],\"default\":null}],\"connect.name\":\"p_presentronik.presentronik.konfigurasi_kelas_jadwal_rutin.Value\"}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }
  @Deprecated public java.lang.CharSequence kd_kelas;
  @Deprecated public int hari_ke;
  @Deprecated public long jam_mulai;
  @Deprecated public long jam_selesai;
  @Deprecated public long tgl_mulai_otomatis_buat_jadwal;
  @Deprecated public long tgl_berakhir_otomatis_buat_jadwal;
  @Deprecated public boolean aktif;
  @Deprecated public java.lang.CharSequence kd_mk;
  @Deprecated public java.lang.CharSequence nama_mk;
  @Deprecated public java.lang.CharSequence nama_kelas;
  @Deprecated public java.lang.CharSequence nama_hari;
  @Deprecated public long ts_update;
  @Deprecated public java.lang.CharSequence kd_org;
  @Deprecated public java.lang.Integer thn;
  @Deprecated public java.lang.Integer term;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Value() {}

  /**
   * All-args constructor.
   * @param kd_kelas The new value for kd_kelas
   * @param hari_ke The new value for hari_ke
   * @param jam_mulai The new value for jam_mulai
   * @param jam_selesai The new value for jam_selesai
   * @param tgl_mulai_otomatis_buat_jadwal The new value for tgl_mulai_otomatis_buat_jadwal
   * @param tgl_berakhir_otomatis_buat_jadwal The new value for tgl_berakhir_otomatis_buat_jadwal
   * @param aktif The new value for aktif
   * @param kd_mk The new value for kd_mk
   * @param nama_mk The new value for nama_mk
   * @param nama_kelas The new value for nama_kelas
   * @param nama_hari The new value for nama_hari
   * @param ts_update The new value for ts_update
   * @param kd_org The new value for kd_org
   * @param thn The new value for thn
   * @param term The new value for term
   */
  public Value(java.lang.CharSequence kd_kelas, java.lang.Integer hari_ke, java.lang.Long jam_mulai, java.lang.Long jam_selesai, java.lang.Long tgl_mulai_otomatis_buat_jadwal, java.lang.Long tgl_berakhir_otomatis_buat_jadwal, java.lang.Boolean aktif, java.lang.CharSequence kd_mk, java.lang.CharSequence nama_mk, java.lang.CharSequence nama_kelas, java.lang.CharSequence nama_hari, java.lang.Long ts_update, java.lang.CharSequence kd_org, java.lang.Integer thn, java.lang.Integer term) {
    this.kd_kelas = kd_kelas;
    this.hari_ke = hari_ke;
    this.jam_mulai = jam_mulai;
    this.jam_selesai = jam_selesai;
    this.tgl_mulai_otomatis_buat_jadwal = tgl_mulai_otomatis_buat_jadwal;
    this.tgl_berakhir_otomatis_buat_jadwal = tgl_berakhir_otomatis_buat_jadwal;
    this.aktif = aktif;
    this.kd_mk = kd_mk;
    this.nama_mk = nama_mk;
    this.nama_kelas = nama_kelas;
    this.nama_hari = nama_hari;
    this.ts_update = ts_update;
    this.kd_org = kd_org;
    this.thn = thn;
    this.term = term;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return kd_kelas;
    case 1: return hari_ke;
    case 2: return jam_mulai;
    case 3: return jam_selesai;
    case 4: return tgl_mulai_otomatis_buat_jadwal;
    case 5: return tgl_berakhir_otomatis_buat_jadwal;
    case 6: return aktif;
    case 7: return kd_mk;
    case 8: return nama_mk;
    case 9: return nama_kelas;
    case 10: return nama_hari;
    case 11: return ts_update;
    case 12: return kd_org;
    case 13: return thn;
    case 14: return term;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: kd_kelas = (java.lang.CharSequence)value$; break;
    case 1: hari_ke = (java.lang.Integer)value$; break;
    case 2: jam_mulai = (java.lang.Long)value$; break;
    case 3: jam_selesai = (java.lang.Long)value$; break;
    case 4: tgl_mulai_otomatis_buat_jadwal = (java.lang.Long)value$; break;
    case 5: tgl_berakhir_otomatis_buat_jadwal = (java.lang.Long)value$; break;
    case 6: aktif = (java.lang.Boolean)value$; break;
    case 7: kd_mk = (java.lang.CharSequence)value$; break;
    case 8: nama_mk = (java.lang.CharSequence)value$; break;
    case 9: nama_kelas = (java.lang.CharSequence)value$; break;
    case 10: nama_hari = (java.lang.CharSequence)value$; break;
    case 11: ts_update = (java.lang.Long)value$; break;
    case 12: kd_org = (java.lang.CharSequence)value$; break;
    case 13: thn = (java.lang.Integer)value$; break;
    case 14: term = (java.lang.Integer)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'kd_kelas' field.
   * @return The value of the 'kd_kelas' field.
   */
  public java.lang.CharSequence getKdKelas() {
    return kd_kelas;
  }

  /**
   * Sets the value of the 'kd_kelas' field.
   * @param value the value to set.
   */
  public void setKdKelas(java.lang.CharSequence value) {
    this.kd_kelas = value;
  }

  /**
   * Gets the value of the 'hari_ke' field.
   * @return The value of the 'hari_ke' field.
   */
  public java.lang.Integer getHariKe() {
    return hari_ke;
  }

  /**
   * Sets the value of the 'hari_ke' field.
   * @param value the value to set.
   */
  public void setHariKe(java.lang.Integer value) {
    this.hari_ke = value;
  }

  /**
   * Gets the value of the 'jam_mulai' field.
   * @return The value of the 'jam_mulai' field.
   */
  public java.lang.Long getJamMulai() {
    return jam_mulai;
  }

  /**
   * Sets the value of the 'jam_mulai' field.
   * @param value the value to set.
   */
  public void setJamMulai(java.lang.Long value) {
    this.jam_mulai = value;
  }

  /**
   * Gets the value of the 'jam_selesai' field.
   * @return The value of the 'jam_selesai' field.
   */
  public java.lang.Long getJamSelesai() {
    return jam_selesai;
  }

  /**
   * Sets the value of the 'jam_selesai' field.
   * @param value the value to set.
   */
  public void setJamSelesai(java.lang.Long value) {
    this.jam_selesai = value;
  }

  /**
   * Gets the value of the 'tgl_mulai_otomatis_buat_jadwal' field.
   * @return The value of the 'tgl_mulai_otomatis_buat_jadwal' field.
   */
  public java.lang.Long getTglMulaiOtomatisBuatJadwal() {
    return tgl_mulai_otomatis_buat_jadwal;
  }

  /**
   * Sets the value of the 'tgl_mulai_otomatis_buat_jadwal' field.
   * @param value the value to set.
   */
  public void setTglMulaiOtomatisBuatJadwal(java.lang.Long value) {
    this.tgl_mulai_otomatis_buat_jadwal = value;
  }

  /**
   * Gets the value of the 'tgl_berakhir_otomatis_buat_jadwal' field.
   * @return The value of the 'tgl_berakhir_otomatis_buat_jadwal' field.
   */
  public java.lang.Long getTglBerakhirOtomatisBuatJadwal() {
    return tgl_berakhir_otomatis_buat_jadwal;
  }

  /**
   * Sets the value of the 'tgl_berakhir_otomatis_buat_jadwal' field.
   * @param value the value to set.
   */
  public void setTglBerakhirOtomatisBuatJadwal(java.lang.Long value) {
    this.tgl_berakhir_otomatis_buat_jadwal = value;
  }

  /**
   * Gets the value of the 'aktif' field.
   * @return The value of the 'aktif' field.
   */
  public java.lang.Boolean getAktif() {
    return aktif;
  }

  /**
   * Sets the value of the 'aktif' field.
   * @param value the value to set.
   */
  public void setAktif(java.lang.Boolean value) {
    this.aktif = value;
  }

  /**
   * Gets the value of the 'kd_mk' field.
   * @return The value of the 'kd_mk' field.
   */
  public java.lang.CharSequence getKdMk() {
    return kd_mk;
  }

  /**
   * Sets the value of the 'kd_mk' field.
   * @param value the value to set.
   */
  public void setKdMk(java.lang.CharSequence value) {
    this.kd_mk = value;
  }

  /**
   * Gets the value of the 'nama_mk' field.
   * @return The value of the 'nama_mk' field.
   */
  public java.lang.CharSequence getNamaMk() {
    return nama_mk;
  }

  /**
   * Sets the value of the 'nama_mk' field.
   * @param value the value to set.
   */
  public void setNamaMk(java.lang.CharSequence value) {
    this.nama_mk = value;
  }

  /**
   * Gets the value of the 'nama_kelas' field.
   * @return The value of the 'nama_kelas' field.
   */
  public java.lang.CharSequence getNamaKelas() {
    return nama_kelas;
  }

  /**
   * Sets the value of the 'nama_kelas' field.
   * @param value the value to set.
   */
  public void setNamaKelas(java.lang.CharSequence value) {
    this.nama_kelas = value;
  }

  /**
   * Gets the value of the 'nama_hari' field.
   * @return The value of the 'nama_hari' field.
   */
  public java.lang.CharSequence getNamaHari() {
    return nama_hari;
  }

  /**
   * Sets the value of the 'nama_hari' field.
   * @param value the value to set.
   */
  public void setNamaHari(java.lang.CharSequence value) {
    this.nama_hari = value;
  }

  /**
   * Gets the value of the 'ts_update' field.
   * @return The value of the 'ts_update' field.
   */
  public java.lang.Long getTsUpdate() {
    return ts_update;
  }

  /**
   * Sets the value of the 'ts_update' field.
   * @param value the value to set.
   */
  public void setTsUpdate(java.lang.Long value) {
    this.ts_update = value;
  }

  /**
   * Gets the value of the 'kd_org' field.
   * @return The value of the 'kd_org' field.
   */
  public java.lang.CharSequence getKdOrg() {
    return kd_org;
  }

  /**
   * Sets the value of the 'kd_org' field.
   * @param value the value to set.
   */
  public void setKdOrg(java.lang.CharSequence value) {
    this.kd_org = value;
  }

  /**
   * Gets the value of the 'thn' field.
   * @return The value of the 'thn' field.
   */
  public java.lang.Integer getThn() {
    return thn;
  }

  /**
   * Sets the value of the 'thn' field.
   * @param value the value to set.
   */
  public void setThn(java.lang.Integer value) {
    this.thn = value;
  }

  /**
   * Gets the value of the 'term' field.
   * @return The value of the 'term' field.
   */
  public java.lang.Integer getTerm() {
    return term;
  }

  /**
   * Sets the value of the 'term' field.
   * @param value the value to set.
   */
  public void setTerm(java.lang.Integer value) {
    this.term = value;
  }

  /**
   * Creates a new Value RecordBuilder.
   * @return A new Value RecordBuilder
   */
  public static org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder newBuilder() {
    return new org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder();
  }

  /**
   * Creates a new Value RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Value RecordBuilder
   */
  public static org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder newBuilder(org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder other) {
    return new org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder(other);
  }

  /**
   * Creates a new Value RecordBuilder by copying an existing Value instance.
   * @param other The existing instance to copy.
   * @return A new Value RecordBuilder
   */
  public static org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder newBuilder(org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value other) {
    return new org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder(other);
  }

  /**
   * RecordBuilder for Value instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Value>
    implements org.apache.avro.data.RecordBuilder<Value> {

    private java.lang.CharSequence kd_kelas;
    private int hari_ke;
    private long jam_mulai;
    private long jam_selesai;
    private long tgl_mulai_otomatis_buat_jadwal;
    private long tgl_berakhir_otomatis_buat_jadwal;
    private boolean aktif;
    private java.lang.CharSequence kd_mk;
    private java.lang.CharSequence nama_mk;
    private java.lang.CharSequence nama_kelas;
    private java.lang.CharSequence nama_hari;
    private long ts_update;
    private java.lang.CharSequence kd_org;
    private java.lang.Integer thn;
    private java.lang.Integer term;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.kd_kelas)) {
        this.kd_kelas = data().deepCopy(fields()[0].schema(), other.kd_kelas);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.hari_ke)) {
        this.hari_ke = data().deepCopy(fields()[1].schema(), other.hari_ke);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.jam_mulai)) {
        this.jam_mulai = data().deepCopy(fields()[2].schema(), other.jam_mulai);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.jam_selesai)) {
        this.jam_selesai = data().deepCopy(fields()[3].schema(), other.jam_selesai);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.tgl_mulai_otomatis_buat_jadwal)) {
        this.tgl_mulai_otomatis_buat_jadwal = data().deepCopy(fields()[4].schema(), other.tgl_mulai_otomatis_buat_jadwal);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.tgl_berakhir_otomatis_buat_jadwal)) {
        this.tgl_berakhir_otomatis_buat_jadwal = data().deepCopy(fields()[5].schema(), other.tgl_berakhir_otomatis_buat_jadwal);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.aktif)) {
        this.aktif = data().deepCopy(fields()[6].schema(), other.aktif);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.kd_mk)) {
        this.kd_mk = data().deepCopy(fields()[7].schema(), other.kd_mk);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.nama_mk)) {
        this.nama_mk = data().deepCopy(fields()[8].schema(), other.nama_mk);
        fieldSetFlags()[8] = true;
      }
      if (isValidValue(fields()[9], other.nama_kelas)) {
        this.nama_kelas = data().deepCopy(fields()[9].schema(), other.nama_kelas);
        fieldSetFlags()[9] = true;
      }
      if (isValidValue(fields()[10], other.nama_hari)) {
        this.nama_hari = data().deepCopy(fields()[10].schema(), other.nama_hari);
        fieldSetFlags()[10] = true;
      }
      if (isValidValue(fields()[11], other.ts_update)) {
        this.ts_update = data().deepCopy(fields()[11].schema(), other.ts_update);
        fieldSetFlags()[11] = true;
      }
      if (isValidValue(fields()[12], other.kd_org)) {
        this.kd_org = data().deepCopy(fields()[12].schema(), other.kd_org);
        fieldSetFlags()[12] = true;
      }
      if (isValidValue(fields()[13], other.thn)) {
        this.thn = data().deepCopy(fields()[13].schema(), other.thn);
        fieldSetFlags()[13] = true;
      }
      if (isValidValue(fields()[14], other.term)) {
        this.term = data().deepCopy(fields()[14].schema(), other.term);
        fieldSetFlags()[14] = true;
      }
    }

    /**
     * Creates a Builder by copying an existing Value instance
     * @param other The existing instance to copy.
     */
    private Builder(org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value other) {
            super(SCHEMA$);
      if (isValidValue(fields()[0], other.kd_kelas)) {
        this.kd_kelas = data().deepCopy(fields()[0].schema(), other.kd_kelas);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.hari_ke)) {
        this.hari_ke = data().deepCopy(fields()[1].schema(), other.hari_ke);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.jam_mulai)) {
        this.jam_mulai = data().deepCopy(fields()[2].schema(), other.jam_mulai);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.jam_selesai)) {
        this.jam_selesai = data().deepCopy(fields()[3].schema(), other.jam_selesai);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.tgl_mulai_otomatis_buat_jadwal)) {
        this.tgl_mulai_otomatis_buat_jadwal = data().deepCopy(fields()[4].schema(), other.tgl_mulai_otomatis_buat_jadwal);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.tgl_berakhir_otomatis_buat_jadwal)) {
        this.tgl_berakhir_otomatis_buat_jadwal = data().deepCopy(fields()[5].schema(), other.tgl_berakhir_otomatis_buat_jadwal);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.aktif)) {
        this.aktif = data().deepCopy(fields()[6].schema(), other.aktif);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.kd_mk)) {
        this.kd_mk = data().deepCopy(fields()[7].schema(), other.kd_mk);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.nama_mk)) {
        this.nama_mk = data().deepCopy(fields()[8].schema(), other.nama_mk);
        fieldSetFlags()[8] = true;
      }
      if (isValidValue(fields()[9], other.nama_kelas)) {
        this.nama_kelas = data().deepCopy(fields()[9].schema(), other.nama_kelas);
        fieldSetFlags()[9] = true;
      }
      if (isValidValue(fields()[10], other.nama_hari)) {
        this.nama_hari = data().deepCopy(fields()[10].schema(), other.nama_hari);
        fieldSetFlags()[10] = true;
      }
      if (isValidValue(fields()[11], other.ts_update)) {
        this.ts_update = data().deepCopy(fields()[11].schema(), other.ts_update);
        fieldSetFlags()[11] = true;
      }
      if (isValidValue(fields()[12], other.kd_org)) {
        this.kd_org = data().deepCopy(fields()[12].schema(), other.kd_org);
        fieldSetFlags()[12] = true;
      }
      if (isValidValue(fields()[13], other.thn)) {
        this.thn = data().deepCopy(fields()[13].schema(), other.thn);
        fieldSetFlags()[13] = true;
      }
      if (isValidValue(fields()[14], other.term)) {
        this.term = data().deepCopy(fields()[14].schema(), other.term);
        fieldSetFlags()[14] = true;
      }
    }

    /**
      * Gets the value of the 'kd_kelas' field.
      * @return The value.
      */
    public java.lang.CharSequence getKdKelas() {
      return kd_kelas;
    }

    /**
      * Sets the value of the 'kd_kelas' field.
      * @param value The value of 'kd_kelas'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setKdKelas(java.lang.CharSequence value) {
      validate(fields()[0], value);
      this.kd_kelas = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'kd_kelas' field has been set.
      * @return True if the 'kd_kelas' field has been set, false otherwise.
      */
    public boolean hasKdKelas() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'kd_kelas' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearKdKelas() {
      kd_kelas = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'hari_ke' field.
      * @return The value.
      */
    public java.lang.Integer getHariKe() {
      return hari_ke;
    }

    /**
      * Sets the value of the 'hari_ke' field.
      * @param value The value of 'hari_ke'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setHariKe(int value) {
      validate(fields()[1], value);
      this.hari_ke = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'hari_ke' field has been set.
      * @return True if the 'hari_ke' field has been set, false otherwise.
      */
    public boolean hasHariKe() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'hari_ke' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearHariKe() {
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'jam_mulai' field.
      * @return The value.
      */
    public java.lang.Long getJamMulai() {
      return jam_mulai;
    }

    /**
      * Sets the value of the 'jam_mulai' field.
      * @param value The value of 'jam_mulai'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setJamMulai(long value) {
      validate(fields()[2], value);
      this.jam_mulai = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'jam_mulai' field has been set.
      * @return True if the 'jam_mulai' field has been set, false otherwise.
      */
    public boolean hasJamMulai() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'jam_mulai' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearJamMulai() {
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'jam_selesai' field.
      * @return The value.
      */
    public java.lang.Long getJamSelesai() {
      return jam_selesai;
    }

    /**
      * Sets the value of the 'jam_selesai' field.
      * @param value The value of 'jam_selesai'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setJamSelesai(long value) {
      validate(fields()[3], value);
      this.jam_selesai = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'jam_selesai' field has been set.
      * @return True if the 'jam_selesai' field has been set, false otherwise.
      */
    public boolean hasJamSelesai() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'jam_selesai' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearJamSelesai() {
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'tgl_mulai_otomatis_buat_jadwal' field.
      * @return The value.
      */
    public java.lang.Long getTglMulaiOtomatisBuatJadwal() {
      return tgl_mulai_otomatis_buat_jadwal;
    }

    /**
      * Sets the value of the 'tgl_mulai_otomatis_buat_jadwal' field.
      * @param value The value of 'tgl_mulai_otomatis_buat_jadwal'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setTglMulaiOtomatisBuatJadwal(long value) {
      validate(fields()[4], value);
      this.tgl_mulai_otomatis_buat_jadwal = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'tgl_mulai_otomatis_buat_jadwal' field has been set.
      * @return True if the 'tgl_mulai_otomatis_buat_jadwal' field has been set, false otherwise.
      */
    public boolean hasTglMulaiOtomatisBuatJadwal() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'tgl_mulai_otomatis_buat_jadwal' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearTglMulaiOtomatisBuatJadwal() {
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'tgl_berakhir_otomatis_buat_jadwal' field.
      * @return The value.
      */
    public java.lang.Long getTglBerakhirOtomatisBuatJadwal() {
      return tgl_berakhir_otomatis_buat_jadwal;
    }

    /**
      * Sets the value of the 'tgl_berakhir_otomatis_buat_jadwal' field.
      * @param value The value of 'tgl_berakhir_otomatis_buat_jadwal'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setTglBerakhirOtomatisBuatJadwal(long value) {
      validate(fields()[5], value);
      this.tgl_berakhir_otomatis_buat_jadwal = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'tgl_berakhir_otomatis_buat_jadwal' field has been set.
      * @return True if the 'tgl_berakhir_otomatis_buat_jadwal' field has been set, false otherwise.
      */
    public boolean hasTglBerakhirOtomatisBuatJadwal() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'tgl_berakhir_otomatis_buat_jadwal' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearTglBerakhirOtomatisBuatJadwal() {
      fieldSetFlags()[5] = false;
      return this;
    }

    /**
      * Gets the value of the 'aktif' field.
      * @return The value.
      */
    public java.lang.Boolean getAktif() {
      return aktif;
    }

    /**
      * Sets the value of the 'aktif' field.
      * @param value The value of 'aktif'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setAktif(boolean value) {
      validate(fields()[6], value);
      this.aktif = value;
      fieldSetFlags()[6] = true;
      return this;
    }

    /**
      * Checks whether the 'aktif' field has been set.
      * @return True if the 'aktif' field has been set, false otherwise.
      */
    public boolean hasAktif() {
      return fieldSetFlags()[6];
    }


    /**
      * Clears the value of the 'aktif' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearAktif() {
      fieldSetFlags()[6] = false;
      return this;
    }

    /**
      * Gets the value of the 'kd_mk' field.
      * @return The value.
      */
    public java.lang.CharSequence getKdMk() {
      return kd_mk;
    }

    /**
      * Sets the value of the 'kd_mk' field.
      * @param value The value of 'kd_mk'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setKdMk(java.lang.CharSequence value) {
      validate(fields()[7], value);
      this.kd_mk = value;
      fieldSetFlags()[7] = true;
      return this;
    }

    /**
      * Checks whether the 'kd_mk' field has been set.
      * @return True if the 'kd_mk' field has been set, false otherwise.
      */
    public boolean hasKdMk() {
      return fieldSetFlags()[7];
    }


    /**
      * Clears the value of the 'kd_mk' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearKdMk() {
      kd_mk = null;
      fieldSetFlags()[7] = false;
      return this;
    }

    /**
      * Gets the value of the 'nama_mk' field.
      * @return The value.
      */
    public java.lang.CharSequence getNamaMk() {
      return nama_mk;
    }

    /**
      * Sets the value of the 'nama_mk' field.
      * @param value The value of 'nama_mk'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setNamaMk(java.lang.CharSequence value) {
      validate(fields()[8], value);
      this.nama_mk = value;
      fieldSetFlags()[8] = true;
      return this;
    }

    /**
      * Checks whether the 'nama_mk' field has been set.
      * @return True if the 'nama_mk' field has been set, false otherwise.
      */
    public boolean hasNamaMk() {
      return fieldSetFlags()[8];
    }


    /**
      * Clears the value of the 'nama_mk' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearNamaMk() {
      nama_mk = null;
      fieldSetFlags()[8] = false;
      return this;
    }

    /**
      * Gets the value of the 'nama_kelas' field.
      * @return The value.
      */
    public java.lang.CharSequence getNamaKelas() {
      return nama_kelas;
    }

    /**
      * Sets the value of the 'nama_kelas' field.
      * @param value The value of 'nama_kelas'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setNamaKelas(java.lang.CharSequence value) {
      validate(fields()[9], value);
      this.nama_kelas = value;
      fieldSetFlags()[9] = true;
      return this;
    }

    /**
      * Checks whether the 'nama_kelas' field has been set.
      * @return True if the 'nama_kelas' field has been set, false otherwise.
      */
    public boolean hasNamaKelas() {
      return fieldSetFlags()[9];
    }


    /**
      * Clears the value of the 'nama_kelas' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearNamaKelas() {
      nama_kelas = null;
      fieldSetFlags()[9] = false;
      return this;
    }

    /**
      * Gets the value of the 'nama_hari' field.
      * @return The value.
      */
    public java.lang.CharSequence getNamaHari() {
      return nama_hari;
    }

    /**
      * Sets the value of the 'nama_hari' field.
      * @param value The value of 'nama_hari'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setNamaHari(java.lang.CharSequence value) {
      validate(fields()[10], value);
      this.nama_hari = value;
      fieldSetFlags()[10] = true;
      return this;
    }

    /**
      * Checks whether the 'nama_hari' field has been set.
      * @return True if the 'nama_hari' field has been set, false otherwise.
      */
    public boolean hasNamaHari() {
      return fieldSetFlags()[10];
    }


    /**
      * Clears the value of the 'nama_hari' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearNamaHari() {
      nama_hari = null;
      fieldSetFlags()[10] = false;
      return this;
    }

    /**
      * Gets the value of the 'ts_update' field.
      * @return The value.
      */
    public java.lang.Long getTsUpdate() {
      return ts_update;
    }

    /**
      * Sets the value of the 'ts_update' field.
      * @param value The value of 'ts_update'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setTsUpdate(long value) {
      validate(fields()[11], value);
      this.ts_update = value;
      fieldSetFlags()[11] = true;
      return this;
    }

    /**
      * Checks whether the 'ts_update' field has been set.
      * @return True if the 'ts_update' field has been set, false otherwise.
      */
    public boolean hasTsUpdate() {
      return fieldSetFlags()[11];
    }


    /**
      * Clears the value of the 'ts_update' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearTsUpdate() {
      fieldSetFlags()[11] = false;
      return this;
    }

    /**
      * Gets the value of the 'kd_org' field.
      * @return The value.
      */
    public java.lang.CharSequence getKdOrg() {
      return kd_org;
    }

    /**
      * Sets the value of the 'kd_org' field.
      * @param value The value of 'kd_org'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setKdOrg(java.lang.CharSequence value) {
      validate(fields()[12], value);
      this.kd_org = value;
      fieldSetFlags()[12] = true;
      return this;
    }

    /**
      * Checks whether the 'kd_org' field has been set.
      * @return True if the 'kd_org' field has been set, false otherwise.
      */
    public boolean hasKdOrg() {
      return fieldSetFlags()[12];
    }


    /**
      * Clears the value of the 'kd_org' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearKdOrg() {
      kd_org = null;
      fieldSetFlags()[12] = false;
      return this;
    }

    /**
      * Gets the value of the 'thn' field.
      * @return The value.
      */
    public java.lang.Integer getThn() {
      return thn;
    }

    /**
      * Sets the value of the 'thn' field.
      * @param value The value of 'thn'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setThn(java.lang.Integer value) {
      validate(fields()[13], value);
      this.thn = value;
      fieldSetFlags()[13] = true;
      return this;
    }

    /**
      * Checks whether the 'thn' field has been set.
      * @return True if the 'thn' field has been set, false otherwise.
      */
    public boolean hasThn() {
      return fieldSetFlags()[13];
    }


    /**
      * Clears the value of the 'thn' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearThn() {
      thn = null;
      fieldSetFlags()[13] = false;
      return this;
    }

    /**
      * Gets the value of the 'term' field.
      * @return The value.
      */
    public java.lang.Integer getTerm() {
      return term;
    }

    /**
      * Sets the value of the 'term' field.
      * @param value The value of 'term'.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder setTerm(java.lang.Integer value) {
      validate(fields()[14], value);
      this.term = value;
      fieldSetFlags()[14] = true;
      return this;
    }

    /**
      * Checks whether the 'term' field has been set.
      * @return True if the 'term' field has been set, false otherwise.
      */
    public boolean hasTerm() {
      return fieldSetFlags()[14];
    }


    /**
      * Clears the value of the 'term' field.
      * @return This builder.
      */
    public org.datastream.khodza.model.avro.p_presentronik_konfigurasi_kelas_jadwal_rutin.Value.Builder clearTerm() {
      term = null;
      fieldSetFlags()[14] = false;
      return this;
    }

    @Override
    public Value build() {
      try {
        Value record = new Value();
        record.kd_kelas = fieldSetFlags()[0] ? this.kd_kelas : (java.lang.CharSequence) defaultValue(fields()[0]);
        record.hari_ke = fieldSetFlags()[1] ? this.hari_ke : (java.lang.Integer) defaultValue(fields()[1]);
        record.jam_mulai = fieldSetFlags()[2] ? this.jam_mulai : (java.lang.Long) defaultValue(fields()[2]);
        record.jam_selesai = fieldSetFlags()[3] ? this.jam_selesai : (java.lang.Long) defaultValue(fields()[3]);
        record.tgl_mulai_otomatis_buat_jadwal = fieldSetFlags()[4] ? this.tgl_mulai_otomatis_buat_jadwal : (java.lang.Long) defaultValue(fields()[4]);
        record.tgl_berakhir_otomatis_buat_jadwal = fieldSetFlags()[5] ? this.tgl_berakhir_otomatis_buat_jadwal : (java.lang.Long) defaultValue(fields()[5]);
        record.aktif = fieldSetFlags()[6] ? this.aktif : (java.lang.Boolean) defaultValue(fields()[6]);
        record.kd_mk = fieldSetFlags()[7] ? this.kd_mk : (java.lang.CharSequence) defaultValue(fields()[7]);
        record.nama_mk = fieldSetFlags()[8] ? this.nama_mk : (java.lang.CharSequence) defaultValue(fields()[8]);
        record.nama_kelas = fieldSetFlags()[9] ? this.nama_kelas : (java.lang.CharSequence) defaultValue(fields()[9]);
        record.nama_hari = fieldSetFlags()[10] ? this.nama_hari : (java.lang.CharSequence) defaultValue(fields()[10]);
        record.ts_update = fieldSetFlags()[11] ? this.ts_update : (java.lang.Long) defaultValue(fields()[11]);
        record.kd_org = fieldSetFlags()[12] ? this.kd_org : (java.lang.CharSequence) defaultValue(fields()[12]);
        record.thn = fieldSetFlags()[13] ? this.thn : (java.lang.Integer) defaultValue(fields()[13]);
        record.term = fieldSetFlags()[14] ? this.term : (java.lang.Integer) defaultValue(fields()[14]);
        return record;
      } catch (Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  private static final org.apache.avro.io.DatumWriter
    WRITER$ = new org.apache.avro.specific.SpecificDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  private static final org.apache.avro.io.DatumReader
    READER$ = new org.apache.avro.specific.SpecificDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}
